#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/select.h>

int
main(int argc, char **argv)
{
    const char *test = "test string";
    int pair[2];

    if (socketpair(AF_UNIX, SOCK_STREAM, 0, pair) == -1) {
        printf("socketpair failed\n");
        return 1;
    }
    write(pair[0], test, strlen(test)+1);
    shutdown(pair[0], SHUT_WR);
    for (;;) {
        char buf[256];
        int len;
        fd_set set;

        FD_ZERO(&set);
        FD_SET(pair[1], &set);
        if (select(pair[1] + 1, &set, NULL, NULL, NULL) < 0) {
            printf("select failed\n");
            return 1;
        }
        assert(FD_ISSET(pair[1], &set));
        len = read(pair[1], buf, sizeof(buf));
        if (len < 0) {
            printf("recv failed\n");
            return 1;
        } else if (len > 0) {
            printf("recv: %d bytes\n", len);
        } else {
            printf("recv: EOF\n");
            break;
        }
    }
    close(pair[0]);
    close(pair[1]);
    return 0;
}
